/**
 * tdesign v1.8.5
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _toConsumableArray = require('@babel/runtime/helpers/toConsumableArray');
var vue = require('vue');
var tdesignIconsVueNext = require('tdesign-icons-vue-next');
var button_index = require('../button/index.js');
var popup_index = require('../popup/index.js');
var config = require('../config.js');
var dialog_props = require('./props.js');
var hooks_tnode = require('../hooks/tnode.js');
var hooks_useClass = require('../hooks/useClass.js');
var get = require('../_chunks/dep-ee51a554.js');
var isString = require('../_chunks/dep-e031babb.js');
var isObject = require('../_chunks/dep-6b61da52.js');
require('../button/button.js');
require('../loading/index.js');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../_chunks/dep-88147c3c.js');
require('../_chunks/dep-ee1322e3.js');
require('../_chunks/dep-0334b2f1.js');
require('../_chunks/dep-5bd74ffa.js');
require('../_chunks/dep-e359cf98.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-d8882efd.js');
require('../loading/icon/spinner.js');
require('../loading/props.js');
require('../shared/dom.js');
require('../_chunks/dep-333f1d82.js');
require('../loading/plugin.js');
require('../_chunks/dep-e1c0f7fe.js');
require('../_common/js/global-config/mobile/default-config.js');
require('../_common/js/global-config/mobile/locale/zh_CN.js');
require('../_chunks/dep-2934441b.js');
require('../_chunks/dep-3a644805.js');
require('dayjs');
require('../_chunks/dep-5029e827.js');
require('../_chunks/dep-cfb0e78f.js');
require('../_chunks/dep-31fe6b59.js');
require('../_chunks/dep-e2cd1076.js');
require('../_chunks/dep-142e416b.js');
require('../_chunks/dep-1a60658f.js');
require('../_chunks/dep-6aef49c4.js');
require('../_chunks/dep-9141aa78.js');
require('../_chunks/dep-2c83a65b.js');
require('../_chunks/dep-d57d3ed5.js');
require('../_chunks/dep-8aaa430c.js');
require('../_chunks/dep-54b872a8.js');
require('../_chunks/dep-402efc35.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-0484d708.js');
require('../_chunks/dep-45a683b0.js');
require('../_chunks/dep-f01c346c.js');
require('../_chunks/dep-9289591a.js');
require('../_chunks/dep-f4556ad8.js');
require('../_chunks/dep-b4897936.js');
require('../_chunks/dep-db2c642e.js');
require('../_chunks/dep-86f56bd7.js');
require('../_chunks/dep-9bef960e.js');
require('../_chunks/dep-e718c228.js');
require('../_chunks/dep-2793a292.js');
require('../shared/component.js');
require('../button/props.js');
require('../form/hooks.js');
require('../_chunks/dep-c7596cb6.js');
require('../shared/hover.js');
require('../popup/popup.js');
require('../popup/props.js');
require('../overlay/index.js');
require('../overlay/overlay.js');
require('../overlay/props.js');
require('../hooks/useVModel.js');
require('../hooks/useLockScroll.js');
require('../_util/useTouch.js');
require('../_util/getScrollParent.js');
require('../hooks/useTeleport.js');
require('../shared/render-tnode.js');
require('../_chunks/dep-9ceeb4bb.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var _toConsumableArray__default = /*#__PURE__*/_interopDefaultLegacy(_toConsumableArray);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var prefix = config["default"].prefix;
var Dialog = vue.defineComponent({
  name: "".concat(prefix, "-dialog"),
  props: dialog_props["default"],
  emits: ["update:visible", "confirm", "overlay-click", "cancel", "close", "closed"],
  setup: function setup(props2, context) {
    var dialogClass = hooks_useClass.usePrefixClass("dialog");
    var renderTNodeJSX = hooks_tnode.useTNodeJSX();
    var renderContent = hooks_tnode.useContent();
    var isTextStyleBtn = vue.computed(function () {
      return [props2 === null || props2 === void 0 ? void 0 : props2.confirmBtn, props2 === null || props2 === void 0 ? void 0 : props2.cancelBtn].concat(_toConsumableArray__default["default"]((props2 === null || props2 === void 0 ? void 0 : props2.actions) || [])).some(function (item) {
        return get.get(item, "variant") === "text";
      });
    });
    var footerClass = vue.computed(function () {
      return ["".concat(dialogClass.value, "__footer"), _defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(dialogClass.value, "__footer--column"), props2.buttonLayout === "vertical"), "".concat(dialogClass.value, "__footer--full"), isTextStyleBtn.value && get.get(props2.actions, "length", 0) === 0)];
    });
    var buttonClass = vue.computed(function () {
      return ["".concat(dialogClass.value, "__button"), _defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(dialogClass.value, "__button--").concat(props2.buttonLayout), !isTextStyleBtn.value), "".concat(dialogClass.value, "__button--text"), isTextStyleBtn.value)];
    });
    var rootStyles = vue.computed(function () {
      return {
        width: isString.isString(props2.width) ? props2.width : "".concat(props2.width, "px")
      };
    });
    var handleClose = function handleClose(args) {
      var e = args.e;
      context.emit("update:visible", false);
      context.emit("close", {
        e: e,
        trigger: "close-btn"
      });
    };
    var handleClosed = function handleClosed() {
      context.emit("closed");
    };
    var handleConfirm = function handleConfirm(e) {
      var _context$emit;
      context.emit("update:visible", false);
      (_context$emit = context.emit) === null || _context$emit === void 0 || _context$emit.call(context, "confirm", {
        e: e
      });
    };
    var handleCancel = function handleCancel(e) {
      context.emit("update:visible", false);
      context.emit("close", {
        e: e,
        trigger: "cancel"
      });
      context.emit("cancel", {
        e: e
      });
    };
    var handleOverlayClick = function handleOverlayClick(args) {
      var e = args.e;
      if (!props2.closeOnOverlayClick) {
        return;
      }
      context.emit("update:visible", false);
      context.emit("close", {
        e: e,
        trigger: "overlay"
      });
      context.emit("overlay-click", {
        e: e
      });
    };
    var calcBtn = function calcBtn(btn) {
      if (isString.isString(btn)) {
        return {
          content: btn
        };
      }
      if (isObject.isObject(btn)) {
        return btn;
      }
      return {};
    };
    var confirmBtnProps = vue.computed(function () {
      return _objectSpread({
        theme: "primary"
      }, calcBtn(props2.confirmBtn));
    });
    var cancelBtnProps = vue.computed(function () {
      return _objectSpread({
        theme: isTextStyleBtn.value ? "default" : "light"
      }, calcBtn(props2.cancelBtn));
    });
    var actionsBtnProps = vue.computed(function () {
      var _props2$actions;
      return (_props2$actions = props2.actions) === null || _props2$actions === void 0 ? void 0 : _props2$actions.map(function (item) {
        return calcBtn(item);
      });
    });
    return function () {
      var renderTitleNode = function renderTitleNode() {
        var titleNode = renderTNodeJSX("title");
        if (!titleNode) {
          return null;
        }
        return vue.createVNode("div", {
          "class": "".concat(dialogClass.value, "__header")
        }, [titleNode]);
      };
      var renderContentNode = function renderContentNode() {
        var contentNode = renderContent("default", "content");
        if (!contentNode) {
          return null;
        }
        return vue.createVNode("div", {
          "class": "".concat(dialogClass.value, "__body")
        }, [vue.createVNode("div", {
          "class": "".concat(dialogClass.value, "__body-text")
        }, [contentNode])]);
      };
      var renderActionsNode = function renderActionsNode() {
        var actionsNode = renderTNodeJSX("actions");
        if (actionsNode && actionsBtnProps.value) {
          return actionsBtnProps.value.map(function (item, index) {
            return vue.createVNode(button_index.Button, vue.mergeProps({
              "key": index
            }, item, {
              "class": buttonClass.value,
              "onClick": handleCancel
            }), null);
          });
        }
        return null;
      };
      var renderCancelBtnNode = function renderCancelBtnNode() {
        var cancelBtnNode = renderTNodeJSX("cancelBtn");
        if (!props2.actions && cancelBtnNode) {
          if (context.slots.cancelBtn) {
            return cancelBtnNode;
          }
          return vue.createVNode(button_index.Button, vue.mergeProps(cancelBtnProps.value, {
            "class": buttonClass.value,
            "onClick": handleCancel
          }), null);
        }
        return null;
      };
      var renderConfirmBntNode = function renderConfirmBntNode() {
        var confirmBtnNode = renderTNodeJSX("confirmBtn");
        if (!props2.actions && confirmBtnNode) {
          if (context.slots.confirmBtn) {
            return confirmBtnNode;
          }
          return vue.createVNode(button_index.Button, vue.mergeProps(confirmBtnProps.value, {
            "class": buttonClass.value,
            "onClick": handleConfirm
          }), null);
        }
        return null;
      };
      return vue.createVNode(popup_index.Popup, {
        "class": "".concat(dialogClass.value, "__wrapper"),
        "visible": props2.visible,
        "placement": "center",
        "show-overlay": props2.showOverlay,
        "overlay-props": props2.overlayProps,
        "prevent-scroll-through": props2.preventScrollThrough,
        "destroy-on-close": props2.destroyOnClose,
        "z-index": props2.zIndex,
        "onClose": handleOverlayClick,
        "onClosed": handleClosed
      }, {
        default: function _default() {
          return [vue.createVNode("div", {
            "class": "".concat(dialogClass.value, " ").concat(context.attrs.class || ""),
            "style": rootStyles.value
          }, [renderTNodeJSX("top"), props2.closeBtn && vue.createVNode("div", {
            "class": "".concat(dialogClass.value, "__close-btn")
          }, [vue.createVNode(tdesignIconsVueNext.CloseIcon, {
            "onClick": handleClose
          }, null)]), vue.createVNode("div", {
            "class": "".concat(dialogClass.value, "__content")
          }, [renderTitleNode(), renderContentNode()]), renderTNodeJSX("middle"), vue.createVNode("div", {
            "class": footerClass.value
          }, [renderActionsNode(), renderCancelBtnNode(), renderConfirmBntNode()])])];
        }
      });
    };
  }
});

exports["default"] = Dialog;
//# sourceMappingURL=dialog.js.map
