/**
 * tdesign v1.8.5
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var image_index = require('../image/index.js');
var empty_props = require('./props.js');
var config = require('../config.js');
var hooks_useClass = require('../hooks/useClass.js');
var hooks_tnode = require('../hooks/tnode.js');
require('../image/image.js');
require('@babel/runtime/helpers/slicedToArray');
require('@babel/runtime/helpers/defineProperty');
require('@vueuse/core');
require('tdesign-icons-vue-next');
require('../loading/index.js');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-88147c3c.js');
require('../_chunks/dep-ee1322e3.js');
require('../_chunks/dep-e031babb.js');
require('../_chunks/dep-e359cf98.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-0334b2f1.js');
require('../_chunks/dep-d8882efd.js');
require('../_chunks/dep-5bd74ffa.js');
require('../loading/icon/spinner.js');
require('../loading/props.js');
require('../shared/dom.js');
require('../_chunks/dep-333f1d82.js');
require('../_chunks/dep-6b61da52.js');
require('../loading/plugin.js');
require('../_chunks/dep-e1c0f7fe.js');
require('../_common/js/global-config/mobile/default-config.js');
require('../_common/js/global-config/mobile/locale/zh_CN.js');
require('../_chunks/dep-2934441b.js');
require('../_chunks/dep-3a644805.js');
require('dayjs');
require('../_chunks/dep-5029e827.js');
require('../_chunks/dep-cfb0e78f.js');
require('../_chunks/dep-31fe6b59.js');
require('../_chunks/dep-e2cd1076.js');
require('../_chunks/dep-142e416b.js');
require('../_chunks/dep-1a60658f.js');
require('../_chunks/dep-6aef49c4.js');
require('../_chunks/dep-9141aa78.js');
require('../_chunks/dep-2c83a65b.js');
require('../_chunks/dep-d57d3ed5.js');
require('../_chunks/dep-8aaa430c.js');
require('../_chunks/dep-54b872a8.js');
require('../_chunks/dep-402efc35.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-0484d708.js');
require('../_chunks/dep-45a683b0.js');
require('../_chunks/dep-f01c346c.js');
require('../_chunks/dep-9289591a.js');
require('../_chunks/dep-f4556ad8.js');
require('../_chunks/dep-b4897936.js');
require('../_chunks/dep-db2c642e.js');
require('../_chunks/dep-86f56bd7.js');
require('../_chunks/dep-9bef960e.js');
require('../_chunks/dep-e718c228.js');
require('../_chunks/dep-2793a292.js');
require('../shared/component.js');
require('../image/props.js');

var prefix = config["default"].prefix;
var _Empty = vue.defineComponent({
  name: "".concat(prefix, "-empty"),
  props: empty_props["default"],
  setup: function setup(props) {
    var renderTNodeJSX = hooks_tnode.useTNodeJSX();
    var emptyClass = hooks_useClass.usePrefixClass("empty");
    return function () {
      var action = renderTNodeJSX("action");
      var description = renderTNodeJSX("description");
      var readerThumb = function readerThumb() {
        var image = renderTNodeJSX("image");
        if (image) {
          if (typeof props.image === "string") {
            return vue.withDirectives(vue.createVNode(image_index.Image, {
              "src": props.image
            }, null), [[vue.resolveDirective("if"), "typeof image === 'string'"]]);
          }
          return image;
        }
        var icon = renderTNodeJSX("icon");
        if (icon) {
          return vue.createVNode("div", {
            "class": "".concat(emptyClass.value, "__icon")
          }, [icon]);
        }
        return null;
      };
      return vue.createVNode("div", {
        "class": emptyClass.value
      }, [vue.createVNode("div", {
        "class": "".concat(emptyClass.value, "__thumb")
      }, [readerThumb()]), description && vue.createVNode("div", {
        "class": "".concat(emptyClass.value, "__description")
      }, [description]), action && vue.createVNode("div", {
        "class": "".concat(emptyClass.value, "__actions")
      }, [action])]);
    };
  }
});

exports["default"] = _Empty;
//# sourceMappingURL=empty.js.map
