/**
 * tdesign v1.8.5
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var shared_dom = require('../shared/dom.js');
var isFunction = require('../_chunks/dep-333f1d82.js');
require('../_chunks/dep-e031babb.js');
require('../_chunks/dep-e359cf98.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-0334b2f1.js');
require('../_chunks/dep-d8882efd.js');
require('../_chunks/dep-6b61da52.js');

var useTeleport = function useTeleport(attach, triggerNode) {
  var to = isFunction.isFunction(attach) ? vue.computed(attach) : vue.ref(attach);
  var innerTriggerNode = isFunction.isFunction(triggerNode) ? vue.computed(triggerNode) : vue.ref(triggerNode);
  var element = vue.ref();
  var getElement = function getElement() {
    element.value = shared_dom.getSSRAttach() || shared_dom.getAttach(to.value, innerTriggerNode.value);
  };
  vue.onMounted(function () {
    return getElement();
  });
  vue.watch([to, innerTriggerNode], function () {
    return getElement();
  });
  return element;
};

exports["default"] = useTeleport;
//# sourceMappingURL=useTeleport.js.map
