/**
 * tdesign v1.8.5
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var layout_colProps = require('./col-props.js');
var config = require('../config.js');
var layout_constants = require('./constants.js');
var hooks_tnode = require('../hooks/tnode.js');
var hooks_useClass = require('../hooks/useClass.js');
var shared_util = require('../shared/util.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-6b61da52.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-e031babb.js');
require('../_chunks/dep-e359cf98.js');
require('../_chunks/dep-0334b2f1.js');
require('../_chunks/dep-d8882efd.js');
require('../_chunks/dep-0484d708.js');
require('../_chunks/dep-45a683b0.js');
require('../_chunks/dep-f01c346c.js');
require('../_chunks/dep-9289591a.js');
require('../_chunks/dep-f4556ad8.js');
require('../_chunks/dep-b4897936.js');
require('../_chunks/dep-db2c642e.js');
require('../_chunks/dep-333f1d82.js');
require('../_chunks/dep-86f56bd7.js');
require('../_chunks/dep-9bef960e.js');
require('../_chunks/dep-1a60658f.js');
require('../_chunks/dep-6aef49c4.js');
require('../_chunks/dep-9141aa78.js');
require('../_chunks/dep-e2cd1076.js');
require('../_chunks/dep-e718c228.js');
require('@babel/runtime/helpers/defineProperty');
require('../_chunks/dep-e1c0f7fe.js');
require('../_common/js/global-config/mobile/default-config.js');
require('../_common/js/global-config/mobile/locale/zh_CN.js');
require('../_chunks/dep-2934441b.js');
require('../_chunks/dep-3a644805.js');
require('dayjs');
require('../_chunks/dep-5029e827.js');
require('../_chunks/dep-cfb0e78f.js');
require('../_chunks/dep-31fe6b59.js');
require('../_chunks/dep-142e416b.js');
require('../_chunks/dep-2c83a65b.js');
require('../_chunks/dep-d57d3ed5.js');
require('../_chunks/dep-8aaa430c.js');
require('../_chunks/dep-54b872a8.js');
require('../_chunks/dep-402efc35.js');
require('../_chunks/dep-2793a292.js');
require('@babel/runtime/helpers/slicedToArray');
require('../_chunks/dep-5bd74ffa.js');

var prefix = config["default"].prefix;
var _Col = vue.defineComponent({
  name: "".concat(prefix, "-col"),
  props: layout_colProps["default"],
  setup: function setup(props2) {
    var renderTNodeJSX = hooks_tnode.useTNodeJSX();
    var colClass = hooks_useClass.usePrefixClass("col");
    var _inject = vue.inject(layout_constants.rowInjectionKey),
      gutter = _inject.gutter;
    var style = vue.computed(function () {
      var styles = {};
      if (!gutter) {
        return styles;
      }
      var gutterVal = shared_util.convertUnit(Number(gutter) / 2);
      styles.paddingRight = gutterVal;
      styles.paddingLeft = gutterVal;
      return styles;
    });
    var rootClass = vue.computed(function () {
      var rootClass2 = colClass.value;
      if (props2.offset) {
        rootClass2 += " ".concat(colClass.value, "--offset-").concat(props2.offset);
      }
      if (props2.span) {
        rootClass2 += " ".concat(colClass.value, "--").concat(props2.span);
      }
      return rootClass2;
    });
    return function () {
      return vue.createVNode("div", {
        "class": rootClass.value,
        "style": style.value
      }, [renderTNodeJSX("default")]);
    };
  }
});

exports["default"] = _Col;
//# sourceMappingURL=col.js.map
