/**
 * tdesign v1.8.5
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var _common_js_loading_circleAdapter = require('../../_common/js/loading/circle-adapter.js');
var config = require('../../config.js');
var hooks_useClass = require('../../hooks/useClass.js');
require('@babel/runtime/helpers/defineProperty');
require('../../_common/js/utils/setStyle.js');
require('../../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../../_chunks/dep-88147c3c.js');
require('../../_chunks/dep-ee1322e3.js');
require('../../_chunks/dep-e031babb.js');
require('../../_chunks/dep-e359cf98.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-0334b2f1.js');
require('../../_chunks/dep-d8882efd.js');
require('../../_chunks/dep-5bd74ffa.js');
require('../../_chunks/dep-e718c228.js');
require('../../_chunks/dep-e1c0f7fe.js');
require('../../_common/js/global-config/mobile/default-config.js');
require('../../_common/js/global-config/mobile/locale/zh_CN.js');
require('../../_chunks/dep-2934441b.js');
require('../../_chunks/dep-3a644805.js');
require('dayjs');
require('../../_chunks/dep-5029e827.js');
require('../../_chunks/dep-cfb0e78f.js');
require('../../_chunks/dep-31fe6b59.js');
require('../../_chunks/dep-e2cd1076.js');
require('../../_chunks/dep-333f1d82.js');
require('../../_chunks/dep-6b61da52.js');
require('../../_chunks/dep-142e416b.js');
require('../../_chunks/dep-1a60658f.js');
require('../../_chunks/dep-6aef49c4.js');
require('../../_chunks/dep-9141aa78.js');
require('../../_chunks/dep-2c83a65b.js');
require('../../_chunks/dep-d57d3ed5.js');
require('../../_chunks/dep-8aaa430c.js');
require('../../_chunks/dep-54b872a8.js');
require('../../_chunks/dep-402efc35.js');
require('../../_chunks/dep-2793a292.js');
require('../../_chunks/dep-9bef960e.js');

var prefix = config["default"].prefix;
var TGradientIcon = vue.defineComponent({
  name: "".concat(prefix, "-gradient"),
  props: {
    style: Object
  },
  setup: function setup(props) {
    var gradientClass = hooks_useClass.usePrefixClass("loading__gradient");
    var classes = [gradientClass.value, "".concat(prefix, "-icon-loading")];
    var circle = vue.ref();
    var updateColor = function updateColor() {
      var circleElem = circle.value;
      _common_js_loading_circleAdapter["default"](circleElem);
    };
    vue.onMounted(function () {
      vue.nextTick(function () {
        updateColor();
      });
    });
    vue.onUpdated(function () {
      updateColor();
    });
    return function () {
      return vue.createVNode("svg", {
        "style": props.style,
        "class": classes,
        "viewBox": "0 0 12 12",
        "version": "1.1",
        "width": "1em",
        "height": "1em",
        "xmlns": "http://www.w3.org/2000/svg"
      }, [vue.createVNode("foreignObject", {
        "x": "0",
        "y": "0",
        "width": "12",
        "height": "12"
      }, [vue.createVNode("div", {
        "ref": circle,
        "class": "".concat(gradientClass.value, "-conic")
      }, null)])]);
    };
  }
});

exports["default"] = TGradientIcon;
//# sourceMappingURL=gradient.js.map
