/**
 * tdesign v1.8.5
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var isArray = require('../_chunks/dep-0334b2f1.js');
var get = require('../_chunks/dep-ee51a554.js');
require('../_chunks/dep-9ceeb4bb.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-9289591a.js');
require('../_chunks/dep-e359cf98.js');
require('../_chunks/dep-d8882efd.js');
require('../_chunks/dep-d57d3ed5.js');
require('../_chunks/dep-e2cd1076.js');
require('../_chunks/dep-333f1d82.js');
require('../_chunks/dep-6b61da52.js');
require('../_chunks/dep-142e416b.js');
require('../_chunks/dep-45a683b0.js');
require('../_chunks/dep-f01c346c.js');

var isMultipleArray = function isMultipleArray(arr) {
  return isArray.isArray(arr[0]);
};
var getPickerColumns = function getPickerColumns(columns) {
  return isMultipleArray(columns) ? columns : [columns];
};
var limitNumberInRange = function limitNumberInRange(num, min, max) {
  return Math.min(Math.max(num, min), max);
};
function findIndexOfEnabledOption(options, startIndex, keys) {
  var limitStartIndex = limitNumberInRange(startIndex, 0, options.length - 1);
  var forwardIndex = options.findIndex(function (opt, idx) {
    var _keys$disabled;
    return !get.get(opt, (_keys$disabled = keys === null || keys === void 0 ? void 0 : keys.disabled) !== null && _keys$disabled !== void 0 ? _keys$disabled : "disabled") && idx >= limitStartIndex;
  });
  if (forwardIndex !== -1) {
    return forwardIndex;
  }
  var backwardIndex = options.slice(0, limitStartIndex).reverse().findIndex(function (opt) {
    var _keys$disabled2;
    return !get.get(opt, (_keys$disabled2 = keys === null || keys === void 0 ? void 0 : keys.disabled) !== null && _keys$disabled2 !== void 0 ? _keys$disabled2 : "disabled");
  });
  if (backwardIndex !== -1) {
    return limitStartIndex - 1 - backwardIndex;
  }
  return 0;
}

exports.findIndexOfEnabledOption = findIndexOfEnabledOption;
exports.getPickerColumns = getPickerColumns;
exports.isMultipleArray = isMultipleArray;
exports.limitNumberInRange = limitNumberInRange;
//# sourceMappingURL=utils.js.map
