/**
 * tdesign v1.8.5
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var vue = require('vue');
var tdesignIconsVueNext = require('tdesign-icons-vue-next');
var popup_props = require('./props.js');
var overlay_index = require('../overlay/index.js');
var config = require('../config.js');
var hooks_useVModel = require('../hooks/useVModel.js');
var hooks_useClass = require('../hooks/useClass.js');
var hooks_useLockScroll = require('../hooks/useLockScroll.js');
var hooks_tnode = require('../hooks/tnode.js');
var hooks_useTeleport = require('../hooks/useTeleport.js');
var shared_renderTnode = require('../shared/render-tnode.js');
require('../overlay/overlay.js');
require('../shared/dom.js');
require('../_chunks/dep-333f1d82.js');
require('../_chunks/dep-e359cf98.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-6b61da52.js');
require('../_chunks/dep-e031babb.js');
require('../_chunks/dep-0334b2f1.js');
require('../_chunks/dep-d8882efd.js');
require('../overlay/props.js');
require('../_chunks/dep-e718c228.js');
require('../_chunks/dep-e1c0f7fe.js');
require('../_common/js/global-config/mobile/default-config.js');
require('../_common/js/global-config/mobile/locale/zh_CN.js');
require('../_chunks/dep-2934441b.js');
require('../_chunks/dep-3a644805.js');
require('dayjs');
require('../_chunks/dep-5029e827.js');
require('../_chunks/dep-cfb0e78f.js');
require('../_chunks/dep-31fe6b59.js');
require('../_chunks/dep-e2cd1076.js');
require('../_chunks/dep-142e416b.js');
require('../_chunks/dep-1a60658f.js');
require('../_chunks/dep-6aef49c4.js');
require('../_chunks/dep-9141aa78.js');
require('../_chunks/dep-2c83a65b.js');
require('../_chunks/dep-d57d3ed5.js');
require('../_chunks/dep-8aaa430c.js');
require('../_chunks/dep-54b872a8.js');
require('../_chunks/dep-402efc35.js');
require('../_chunks/dep-2793a292.js');
require('../_chunks/dep-9bef960e.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-0484d708.js');
require('../_chunks/dep-45a683b0.js');
require('../_chunks/dep-f01c346c.js');
require('../_chunks/dep-9289591a.js');
require('../_chunks/dep-f4556ad8.js');
require('../_chunks/dep-b4897936.js');
require('../_chunks/dep-db2c642e.js');
require('../_chunks/dep-86f56bd7.js');
require('../shared/component.js');
require('../_util/useTouch.js');
require('../_util/getScrollParent.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var prefix = config["default"].prefix;
var _Popup = vue.defineComponent({
  name: "".concat(prefix, "-popup"),
  components: {
    TNode: shared_renderTnode["default"],
    TOverlay: overlay_index.Overlay
  },
  inheritAttrs: false,
  props: popup_props["default"],
  emits: ["open", "close", "opened", "closed", "visible-change", "update:visible", "update:modelValue"],
  setup: function setup(props, context) {
    var popupClass = hooks_useClass.usePrefixClass("popup");
    var popupRef = vue.ref();
    var renderTNodeContent = hooks_tnode.useContent();
    var renderTNodeJSX = hooks_tnode.useTNodeJSX();
    var _toRefs = vue.toRefs(props),
      visible = _toRefs.visible,
      modelValue = _toRefs.modelValue;
    var _useVModel = hooks_useVModel["default"](visible, modelValue, props.defaultVisible, props.onVisibleChange, "visible"),
      _useVModel2 = _slicedToArray__default["default"](_useVModel, 2),
      currentVisible = _useVModel2[0],
      setCurrentVisible = _useVModel2[1];
    var wrapperVisible = vue.ref(currentVisible.value);
    var innerVisible = vue.ref(currentVisible.value);
    vue.watch(currentVisible, function (v) {
      if (v) {
        wrapperVisible.value = v;
        if (props.destroyOnClose) {
          vue.nextTick(function () {
            innerVisible.value = v;
          });
        } else {
          innerVisible.value = v;
        }
      } else {
        innerVisible.value = v;
      }
    });
    var rootStyles = vue.computed(function () {
      var styles = {};
      if (props.zIndex) {
        styles.zIndex = "".concat(props.zIndex);
      }
      return _objectSpread(_objectSpread({}, context.attrs.style), styles);
    });
    var contentClasses = vue.computed(function () {
      return _defineProperty__default["default"]({}, "".concat(popupClass.value, "--").concat(props.placement), true);
    });
    var contentTransitionName = vue.computed(function () {
      var transitionName = props.transitionName,
        placement = props.placement;
      if (transitionName) return transitionName;
      if (placement === "center") return "fade-zoom";
      return "slide-".concat(placement);
    });
    var closeBtnNode = vue.computed(function () {
      return renderTNodeJSX("closeBtn", vue.h(tdesignIconsVueNext.CloseIcon, {
        size: "24px"
      }));
    });
    var handleCloseClick = function handleCloseClick(e) {
      var _props$onClose;
      (_props$onClose = props.onClose) === null || _props$onClose === void 0 || _props$onClose.call(props, {
        e: e
      });
      setCurrentVisible(false, {
        trigger: "close-btn"
      });
    };
    var handleOverlayClick = function handleOverlayClick(args) {
      var _props$onClose2;
      var e = args.e;
      if (!props.closeOnOverlayClick) {
        return;
      }
      (_props$onClose2 = props.onClose) === null || _props$onClose2 === void 0 || _props$onClose2.call(props, {
        e: e
      });
      setCurrentVisible(false, {
        trigger: "overlay"
      });
    };
    var afterLeave = function afterLeave() {
      var _props$onClosed;
      wrapperVisible.value = false;
      (_props$onClosed = props.onClosed) === null || _props$onClosed === void 0 || _props$onClosed.call(props);
    };
    var afterEnter = function afterEnter() {
      var _props$onOpened;
      return (_props$onOpened = props.onOpened) === null || _props$onOpened === void 0 ? void 0 : _props$onOpened.call(props);
    };
    var teleportElement = hooks_useTeleport["default"](function () {
      return props.attach;
    });
    vue.watch(function () {
      return currentVisible.value;
    }, function (val) {
      if (val) {
        var _props$onOpen;
        (_props$onOpen = props.onOpen) === null || _props$onOpen === void 0 || _props$onOpen.call(props);
      }
    });
    hooks_useLockScroll.useLockScroll(popupRef, function () {
      return wrapperVisible.value && props.preventScrollThrough;
    }, popupClass.value);
    return function () {
      var renderOverlayContent = vue.createVNode(overlay_index.Overlay, vue.mergeProps(props.overlayProps, {
        "visible": innerVisible.value && props.showOverlay,
        "onClick": handleOverlayClick
      }), null);
      var renderCloseBtn = closeBtnNode.value && vue.createVNode("div", {
        "class": "".concat(popupClass.value, "__close"),
        "onClick": handleCloseClick
      }, [closeBtnNode.value]);
      var renderContent = vue.createVNode(vue.Transition, {
        "name": contentTransitionName.value,
        "onAfterEnter": afterEnter,
        "onAfterLeave": afterLeave
      }, {
        default: function _default() {
          return [vue.withDirectives(vue.createVNode("div", vue.mergeProps({
            "ref": popupRef
          }, context.attrs, {
            "class": [popupClass.value, context.attrs.class, contentClasses.value],
            "style": rootStyles.value
          }), [renderCloseBtn, renderTNodeContent("default", "content")]), [[vue.vShow, innerVisible.value]])];
        }
      });
      var renderPopupContent = vue.createVNode(vue.Teleport, {
        "to": teleportElement.value,
        "disabled": !teleportElement.value
      }, {
        default: function _default() {
          return [renderOverlayContent, renderContent];
        }
      });
      return (!props.destroyOnClose || wrapperVisible.value) && renderPopupContent;
    };
  }
});

exports["default"] = _Popup;
//# sourceMappingURL=popup.js.map
