/**
 * tdesign v1.8.5
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _typeof = require('@babel/runtime/helpers/typeof');
var vue = require('vue');
var camelCase = require('../_chunks/dep-0484d708.js');
require('../_chunks/dep-45a683b0.js');
require('../_chunks/dep-e359cf98.js');
require('../_chunks/dep-f01c346c.js');
require('../_chunks/dep-0334b2f1.js');
require('../_chunks/dep-9289591a.js');
require('../_chunks/dep-d8882efd.js');
require('../_chunks/dep-f4556ad8.js');
require('../_chunks/dep-b4897936.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _typeof__default = /*#__PURE__*/_interopDefaultLegacy(_typeof);

var renderTNode = function renderTNode(instance, name, options) {
  var _instance$slots$name3;
  if (instance === null) {
    return vue.h("", null);
  }
  var params = _typeof__default["default"](options) === "object" && "params" in options ? options.params : null;
  var defaultNode = _typeof__default["default"](options) === "object" && "defaultNode" in options ? options.defaultNode : options;
  var propsNode;
  if (name in instance.props || camelCase.camelCase(name) in instance.props) {
    propsNode = instance.props[name] || instance.props[camelCase.camelCase(name)];
  }
  if (instance.slots[name]) {
    var _instance$slots$name;
    return (_instance$slots$name = instance.slots[name]) === null || _instance$slots$name === void 0 ? void 0 : _instance$slots$name.call(params);
  }
  if (propsNode === true && defaultNode) {
    var _instance$slots$name2;
    return instance.slots[name] ? (_instance$slots$name2 = instance.slots[name]) === null || _instance$slots$name2 === void 0 ? void 0 : _instance$slots$name2.call(params) : defaultNode;
  }
  if (typeof propsNode === "function") {
    vue.setBlockTracking(-1);
    var vnode = propsNode(vue.h, params);
    vue.setBlockTracking(1);
    return vnode;
  }
  var isPropsEmpty = [void 0, params, ""].includes(propsNode);
  if (isPropsEmpty && instance.slots[name]) return (_instance$slots$name3 = instance.slots[name]) === null || _instance$slots$name3 === void 0 ? void 0 : _instance$slots$name3.call(params);
  return propsNode;
};
var renderContent = function renderContent(instance, name1, name2, options) {
  if (instance === null) {
    return vue.h("", null);
  }
  var params = _typeof__default["default"](options) === "object" && "params" in options ? options.params : null;
  var defaultNode = _typeof__default["default"](options) === "object" && "defaultNode" in options ? options.defaultNode : options;
  var toParams = params ? {
    params: params
  } : void 0;
  var node1 = renderTNode(instance, name1, toParams);
  var node2 = renderTNode(instance, name2, toParams);
  var r = [void 0, null, ""].includes(node1) ? node2 : node1;
  return [void 0, null, ""].includes(r) ? defaultNode : r;
};

exports.renderContent = renderContent;
exports.renderTNode = renderTNode;
//# sourceMappingURL=render.js.map
