/**
 * tdesign v1.8.5
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var vue = require('vue');
var table_hooks_useClassName = require('./useClassName.js');
require('../../hooks/useClass.js');
require('../../_chunks/dep-e718c228.js');
require('../../_chunks/dep-e1c0f7fe.js');
require('../../_common/js/global-config/mobile/default-config.js');
require('../../_common/js/global-config/mobile/locale/zh_CN.js');
require('../../_chunks/dep-2934441b.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-3a644805.js');
require('dayjs');
require('../../_chunks/dep-5029e827.js');
require('../../_chunks/dep-cfb0e78f.js');
require('../../_chunks/dep-31fe6b59.js');
require('../../_chunks/dep-e2cd1076.js');
require('../../_chunks/dep-333f1d82.js');
require('../../_chunks/dep-e359cf98.js');
require('../../_chunks/dep-6b61da52.js');
require('../../_chunks/dep-142e416b.js');
require('../../_chunks/dep-1a60658f.js');
require('../../_chunks/dep-d8882efd.js');
require('../../_chunks/dep-6aef49c4.js');
require('../../_chunks/dep-9141aa78.js');
require('../../_chunks/dep-0334b2f1.js');
require('../../_chunks/dep-2c83a65b.js');
require('../../_chunks/dep-d57d3ed5.js');
require('../../_chunks/dep-8aaa430c.js');
require('../../_chunks/dep-54b872a8.js');
require('../../_chunks/dep-402efc35.js');
require('../../_chunks/dep-2793a292.js');
require('../../_chunks/dep-9bef960e.js');
require('../../_chunks/dep-e031babb.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function formatCSSUnit(unit) {
  if (!unit) return unit;
  return isNaN(Number(unit)) ? unit : "".concat(unit, "px");
}
function useStyle(props) {
  var _toRefs = vue.toRefs(props),
    bordered = _toRefs.bordered,
    stripe = _toRefs.stripe,
    verticalAlign = _toRefs.verticalAlign,
    height = _toRefs.height,
    maxHeight = _toRefs.maxHeight,
    tableContentWidth = _toRefs.tableContentWidth;
  var _useClassName = table_hooks_useClassName["default"](),
    tableBaseClass = _useClassName.tableBaseClass,
    tableAlignClasses = _useClassName.tableAlignClasses;
  var tableClasses = vue.computed(function () {
    return [tableBaseClass.table, [tableAlignClasses[(verticalAlign === null || verticalAlign === void 0 ? void 0 : verticalAlign.value) || "middle"]], _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, tableBaseClass.bordered, bordered === null || bordered === void 0 ? void 0 : bordered.value), tableBaseClass.striped, stripe === null || stripe === void 0 ? void 0 : stripe.value), tableBaseClass.loading, props.loading)];
  });
  var tableContentStyles = vue.computed(function () {
    return {
      height: formatCSSUnit(height === null || height === void 0 ? void 0 : height.value),
      maxHeight: formatCSSUnit(maxHeight === null || maxHeight === void 0 ? void 0 : maxHeight.value)
    };
  });
  var tableElementStyles = vue.computed(function () {
    return {
      width: formatCSSUnit(tableContentWidth === null || tableContentWidth === void 0 ? void 0 : tableContentWidth.value)
    };
  });
  return {
    tableClasses: tableClasses,
    tableElementStyles: tableElementStyles,
    tableContentStyles: tableContentStyles
  };
}

exports["default"] = useStyle;
exports.formatCSSUnit = formatCSSUnit;
//# sourceMappingURL=useStyle.js.map
