/**
 * tdesign v1.8.5
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var config = require('../config.js');
var tabs_tabPanelProps = require('./tab-panel-props.js');
var hooks_tnode = require('../hooks/tnode.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-6b61da52.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-e031babb.js');
require('../_chunks/dep-e359cf98.js');
require('../_chunks/dep-0334b2f1.js');
require('../_chunks/dep-d8882efd.js');
require('../_chunks/dep-0484d708.js');
require('../_chunks/dep-45a683b0.js');
require('../_chunks/dep-f01c346c.js');
require('../_chunks/dep-9289591a.js');
require('../_chunks/dep-f4556ad8.js');
require('../_chunks/dep-b4897936.js');
require('../_chunks/dep-db2c642e.js');
require('../_chunks/dep-333f1d82.js');
require('../_chunks/dep-86f56bd7.js');
require('../_chunks/dep-9bef960e.js');
require('../_chunks/dep-1a60658f.js');
require('../_chunks/dep-6aef49c4.js');
require('../_chunks/dep-9141aa78.js');
require('../_chunks/dep-e2cd1076.js');

var prefix = config["default"].prefix;
var TTabNavItem = vue.defineComponent({
  name: "".concat(prefix, "-tab-nav"),
  props: {
    label: tabs_tabPanelProps["default"].label,
    icon: tabs_tabPanelProps["default"].icon
  },
  setup: function setup(props) {
    var renderTNodeJSX = hooks_tnode.useTNodeJSX();
    var renderTNodeContent = hooks_tnode.useContent();
    return function () {
      return vue.createVNode("div", null, [renderTNodeJSX("icon"), renderTNodeContent("default", "label")]);
    };
  }
});

exports["default"] = TTabNavItem;
//# sourceMappingURL=tab-nav-item.js.map
