/**
 * tdesign v1.8.5
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { ref } from 'vue';
import '../shared/index.mjs';
import { isBrowser } from '../shared/util.mjs';
import '../shared/functions.mjs';
import '../shared/component.mjs';
import '../shared/constants.mjs';
import '../config.mjs';
import '../shared/render.mjs';
import '../_chunks/dep-c32fde6f.mjs';
import 'lodash-es';
import '../shared/dom.mjs';
import '../shared/render-tnode.mjs';
import '../shared/useToggle/index.mjs';
import '../shared/useCountDown/index.mjs';
import '../_chunks/dep-193006a3.mjs';
import '../_chunks/dep-3f47bc46.mjs';
import '@vueuse/core';
import '../shared/useCountDown/utils.mjs';
import '../_chunks/dep-a2ad5b0c.mjs';
import '../_chunks/dep-a75faf43.mjs';
import '../shared/useChildSlots/index.mjs';
import '../_chunks/dep-6be01994.mjs';
import '../shared/useTouch/index.mjs';
import '../shared/useScrollParent/index.mjs';
import '../shared/useExpose/index.mjs';
import '../shared/useTest/index.mjs';
import '../_chunks/dep-053cb48c.mjs';
import '../shared/useClickAway/index.mjs';
import '../shared/useGesture/index.mjs';
import '@use-gesture/vanilla';
import '../shared/hover.mjs';

var supportsPassive = ref(false);
if (!isBrowser) {
  try {
    var opts = {};
    Object.defineProperty(opts, "passive", {
      get: function get() {
        supportsPassive.value = true;
        return true;
      }
    });
    window.addEventListener("test-passive", null, opts);
  } catch (e) {}
}

export { supportsPassive };
//# sourceMappingURL=supportsPassive.mjs.map
