/**
 * tdesign v1.8.5
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { defineComponent, createVNode, Fragment } from 'vue';
import config from '../config.mjs';
import props from './props.mjs';
import { provideConfig } from './useConfig.mjs';
import { useTNodeJSX } from '../hooks/tnode.mjs';
import '../_chunks/dep-053cb48c.mjs';
import '../_chunks/dep-c32fde6f.mjs';
import 'lodash-es';
import './context.mjs';
import '../_common/js/global-config/mobile/default-config.mjs';
import '../_common/js/global-config/mobile/locale/zh_CN.mjs';
import '../_chunks/dep-03e8deb3.mjs';
import '../_chunks/dep-3f47bc46.mjs';
import '../_chunks/dep-f4f4cd7d.mjs';
import '../_chunks/dep-39376bb1.mjs';
import './type.mjs';
import '../hooks/render-tnode.mjs';

var prefix = config.prefix;
var name = "".concat(prefix, "-config-provider");
var _ConfigProvider = defineComponent({
  name: name,
  props: props,
  setup: function setup(props2) {
    provideConfig(props2);
    var renderTNodeJSX = useTNodeJSX();
    return function () {
      return createVNode(Fragment, null, [renderTNodeJSX("default")]);
    };
  }
});

export { _ConfigProvider as default };
//# sourceMappingURL=config-provider.mjs.map
