/**
 * tdesign v1.8.5
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { defineComponent, getCurrentInstance, inject, createVNode } from 'vue';
import config from '../config.mjs';
import indexesAnchorProps from './indexes-anchor-props.mjs';
import { usePrefixClass } from '../hooks/useClass.mjs';
import { useTNodeJSX } from '../hooks/tnode.mjs';
import '../config-provider/useConfig.mjs';
import '../_chunks/dep-053cb48c.mjs';
import '../_chunks/dep-c32fde6f.mjs';
import 'lodash-es';
import '../config-provider/context.mjs';
import '../_common/js/global-config/mobile/default-config.mjs';
import '../_common/js/global-config/mobile/locale/zh_CN.mjs';
import '../_chunks/dep-03e8deb3.mjs';
import '../_chunks/dep-3f47bc46.mjs';
import '../_chunks/dep-f4f4cd7d.mjs';
import '../_chunks/dep-39376bb1.mjs';
import '../config-provider/type.mjs';
import '../hooks/render-tnode.mjs';

var prefix = config.prefix;
var _IndexesAnchor = defineComponent({
  name: "".concat(prefix, "-indexes-anchor"),
  props: indexesAnchorProps,
  setup: function setup(props) {
    var readerTNodeJSX = useTNodeJSX();
    var indexesAnchorClass = usePrefixClass("indexes-anchor");
    var instance = getCurrentInstance();
    var indexesProvide = inject("indexesProvide", void 0);
    var proxy = instance.proxy;
    indexesProvide.relation(proxy);
    return function () {
      return createVNode("div", {
        "class": indexesAnchorClass.value,
        "data-index": props.index
      }, [createVNode("div", {
        "class": "".concat(indexesAnchorClass.value, "__wrapper")
      }, [createVNode("div", {
        "class": "".concat(indexesAnchorClass.value, "__slot")
      }, [readerTNodeJSX("default")]), createVNode("div", {
        "class": "".concat(indexesAnchorClass.value, "__header")
      }, [props.index])])]);
    };
  }
});

export { _IndexesAnchor as default };
//# sourceMappingURL=indexes-anchor.mjs.map
