/**
 * tdesign v1.8.5
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { defineComponent, inject, computed, createVNode } from 'vue';
import '../shared/index.mjs';
import props from './col-props.mjs';
import config from '../config.mjs';
import { rowInjectionKey } from './constants.mjs';
import { useTNodeJSX } from '../hooks/tnode.mjs';
import { usePrefixClass } from '../hooks/useClass.mjs';
import { convertUnit } from '../shared/util.mjs';
import '../shared/functions.mjs';
import '../shared/component.mjs';
import '../shared/constants.mjs';
import '../shared/render.mjs';
import '../_chunks/dep-c32fde6f.mjs';
import 'lodash-es';
import '../shared/dom.mjs';
import '../shared/render-tnode.mjs';
import '../shared/useToggle/index.mjs';
import '../shared/useCountDown/index.mjs';
import '../_chunks/dep-193006a3.mjs';
import '../_chunks/dep-3f47bc46.mjs';
import '@vueuse/core';
import '../shared/useCountDown/utils.mjs';
import '../shared/useChildSlots/index.mjs';
import '../_chunks/dep-6be01994.mjs';
import '../_chunks/dep-a75faf43.mjs';
import '../shared/useTouch/index.mjs';
import '../shared/useScrollParent/index.mjs';
import '../shared/useExpose/index.mjs';
import '../shared/useTest/index.mjs';
import '../_chunks/dep-053cb48c.mjs';
import '../shared/useClickAway/index.mjs';
import '../shared/useGesture/index.mjs';
import '../_chunks/dep-a2ad5b0c.mjs';
import '@use-gesture/vanilla';
import '../shared/hover.mjs';
import '../hooks/render-tnode.mjs';
import '../config-provider/useConfig.mjs';
import '../config-provider/context.mjs';
import '../_common/js/global-config/mobile/default-config.mjs';
import '../_common/js/global-config/mobile/locale/zh_CN.mjs';
import '../_chunks/dep-03e8deb3.mjs';
import '../_chunks/dep-f4f4cd7d.mjs';
import '../_chunks/dep-39376bb1.mjs';
import '../config-provider/type.mjs';

var prefix = config.prefix;
var _Col = defineComponent({
  name: "".concat(prefix, "-col"),
  props: props,
  setup: function setup(props2) {
    var renderTNodeJSX = useTNodeJSX();
    var colClass = usePrefixClass("col");
    var _inject = inject(rowInjectionKey),
      gutter = _inject.gutter;
    var style = computed(function () {
      var styles = {};
      if (!gutter) {
        return styles;
      }
      var gutterVal = convertUnit(Number(gutter) / 2);
      styles.paddingRight = gutterVal;
      styles.paddingLeft = gutterVal;
      return styles;
    });
    var rootClass = computed(function () {
      var rootClass2 = colClass.value;
      if (props2.offset) {
        rootClass2 += " ".concat(colClass.value, "--offset-").concat(props2.offset);
      }
      if (props2.span) {
        rootClass2 += " ".concat(colClass.value, "--").concat(props2.span);
      }
      return rootClass2;
    });
    return function () {
      return createVNode("div", {
        "class": rootClass.value,
        "style": style.value
      }, [renderTNodeJSX("default")]);
    };
  }
});

export { _Col as default };
//# sourceMappingURL=col.mjs.map
