/**
 * tdesign v1.8.5
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { _ as _toConsumableArray } from '../../_chunks/dep-6be01994.mjs';
import { defineComponent, createVNode } from 'vue';
import config from '../../config.mjs';
import { usePrefixClass } from '../../hooks/useClass.mjs';
import '../../_chunks/dep-a75faf43.mjs';
import '../../config-provider/useConfig.mjs';
import '../../_chunks/dep-053cb48c.mjs';
import '../../_chunks/dep-c32fde6f.mjs';
import 'lodash-es';
import '../../config-provider/context.mjs';
import '../../_common/js/global-config/mobile/default-config.mjs';
import '../../_common/js/global-config/mobile/locale/zh_CN.mjs';
import '../../_chunks/dep-03e8deb3.mjs';
import '../../_chunks/dep-3f47bc46.mjs';
import '../../_chunks/dep-f4f4cd7d.mjs';
import '../../_chunks/dep-39376bb1.mjs';
import '../../config-provider/type.mjs';

var prefix = config.prefix;
var SpinnerIcon = defineComponent({
  name: "".concat(prefix, "-spinner"),
  props: {
    style: Object
  },
  setup: function setup(props) {
    var spinnerClass = usePrefixClass("loading__spinner");
    return function () {
      return createVNode("span", {
        "class": spinnerClass.value,
        "style": props.style
      }, [_toConsumableArray(new Array(12)).map(function (_, index) {
        return createVNode("i", {
          "class": ["".concat(spinnerClass.value, "--line"), "".concat(spinnerClass.value, "--line-").concat(index + 1)]
        }, null);
      })]);
    };
  }
});

export { SpinnerIcon as default };
//# sourceMappingURL=spinner.mjs.map
