/**
 * tdesign v1.8.5
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { defineComponent, inject, computed, ref, watch, withDirectives, createVNode, vShow } from 'vue';
import config from '../config.mjs';
import props from './tab-panel-props.mjs';
import { useContent } from '../hooks/tnode.mjs';
import { usePrefixClass } from '../hooks/useClass.mjs';
import 'lodash-es';
import '../hooks/render-tnode.mjs';
import '../config-provider/useConfig.mjs';
import '../_chunks/dep-053cb48c.mjs';
import '../_chunks/dep-c32fde6f.mjs';
import '../config-provider/context.mjs';
import '../_common/js/global-config/mobile/default-config.mjs';
import '../_common/js/global-config/mobile/locale/zh_CN.mjs';
import '../_chunks/dep-03e8deb3.mjs';
import '../_chunks/dep-3f47bc46.mjs';
import '../_chunks/dep-f4f4cd7d.mjs';
import '../_chunks/dep-39376bb1.mjs';
import '../config-provider/type.mjs';

var prefix = config.prefix;
var name = "".concat(prefix, "-tab-panel");
var _TabPanel = defineComponent({
  name: name,
  props: props,
  setup: function setup(props2) {
    var renderTNodeContent = useContent();
    var tabPanelClass = usePrefixClass("tab-panel");
    var tabsClass = usePrefixClass("tabs");
    var currentValue = inject("currentValue");
    var isActive = computed(function () {
      return currentValue.value === props2.value;
    });
    var tabPanelClasses = computed(function () {
      return ["".concat(tabPanelClass.value), "".concat(tabsClass.value, "__panel")];
    });
    var isMount = ref(props2.lazy ? isActive.value : true);
    watch(isActive, function () {
      if (isActive.value) {
        if (!isMount.value) {
          isMount.value = true;
        }
      } else if (props2.destroyOnHide) {
        isMount.value = false;
      }
    }, {
      immediate: true
    });
    return function () {
      if (!isMount.value) return null;
      return withDirectives(createVNode("div", {
        "class": tabPanelClasses.value
      }, [renderTNodeContent("default", "panel")]), [[vShow, isActive.value]]);
    };
  }
});

export { _TabPanel as default };
//# sourceMappingURL=tab-panel.mjs.map
